SystemOrganization addCategory: 'Orbeon_Tests'!

TestCase subclass: #FormComparatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

FormComparatorTest subclass: #FormDefinitionComparatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

FormComparatorTest subclass: #FormInstanceComparatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

TestCase subclass: #OrbeonApplicationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

TestCase subclass: #OrbeonFormReaderTest
	instanceVariableNames: 'reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

!OrbeonFormReaderTest methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 16:48'!
setUp

	reader := OrbeonFormReader for: OrbeonFormReader definitionExample.! !

!OrbeonFormReaderTest methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 16:49'!
tearDown

	reader := nil! !

OrbeonFormReaderTest subclass: #OrbeonFormReaderTestExample3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 15:35'!
getXMLForm
	"REMOVE doube single quotes for single quotes ('' --> ') before copying the definition into Orbeon"
	^'<xh:html xmlns:xh="http://www.w3.org/1999/xhtml" xmlns:xf="http://www.w3.org/2002/xforms"
         xmlns:xs="http://www.w3.org/2001/XMLSchema"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns:ev="http://www.w3.org/2001/xml-events"
         xmlns:xi="http://www.w3.org/2001/XInclude"
         xmlns:xxi="http://orbeon.org/oxf/xml/xinclude"
         xmlns:xxf="http://orbeon.org/oxf/xml/xforms"
         xmlns:exf="http://www.exforms.org/exf/1-0"
         xmlns:fr="http://orbeon.org/oxf/xml/form-runner"
         xmlns:saxon="http://saxon.sf.net/"
         xmlns:sql="http://orbeon.org/oxf/xml/sql"
         xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"
         xmlns:fb="http://orbeon.org/oxf/xml/form-builder">
    <xh:head>
        <xh:title>Test</xh:title>
        <xf:model id="fr-form-model" xxf:expose-xpath-types="true">
            <!!-- Main instance -->
            <xf:instance id="fr-form-instance" xxf:exclude-result-prefixes="#all">
                <form>
                    <section-1>
                        <section-1-iteration>
                            <name/>
                            <surname/>
                            <phone/>
                            <mail/>
                            <section-7>
                                <control-8/>
                                <mobile/>
                                <grid-10>
                                    <moneySubject/>
                                    <quantity/>
                                    <currency/>
                                </grid-10>
                            </section-7>
                        </section-1-iteration>
                    </section-1>
                    <section-14>
                        <date1/>
                        <dateTime/>
                        <date2/>
                        <date3/>
                        <details/>
                        <type/>
                        <grid-19>
                            <options/>
                            <otherOptions/>
                        </grid-19>
                        <section-24>
                            <formatedText/>
                        </section-24>
                    </section-14>
                </form>
            </xf:instance>
            <!!-- Bindings -->
            <xf:bind id="fr-form-binds" ref="instance(''fr-form-instance'')">
                <xf:bind id="section-1-bind" name="section-1" ref="section-1">
                    <xf:bind id="section-1-iteration-bind" ref="section-1-iteration"
                             name="section-1-iteration">
                        <xf:bind id="name-bind" name="name" ref="name" required="true()"/>
                        <xf:bind id="surname-bind" ref="surname" name="surname" required="true()"/>
                        <xf:bind id="phone-bind" ref="phone" name="phone"
                                 constraint=". = '''' or matches(., ''^\d{10}$'')"/>
                        <xf:bind id="mail-bind" ref="mail" name="mail" type="xf:email" required="true()"/>
                        <xf:bind id="section-7-bind" ref="section-7" name="section-7">
                            <xf:bind id="control-8-bind" ref="control-8" name="control-8"/>
                            <xf:bind id="mobile-bind" ref="mobile" name="mobile"/>
                            <xf:bind id="grid-10-bind" ref="grid-10" name="grid-10">
                                <xf:bind id="quantity-bind" ref="quantity" name="quantity" type="xf:decimal"/>
                                <xf:bind id="currency-bind" ref="currency" name="currency" type="xf:decimal"/>
                                <xf:bind id="moneySubject-bind" ref="moneySubject" name="moneySubject"/>
                            </xf:bind>
                        </xf:bind>
                    </xf:bind>
                </xf:bind>
                <xf:bind id="section-14-bind" ref="section-14" name="section-14">
                    <xf:bind id="date1-bind" ref="date1" name="date1" type="xf:date"/>
                    <xf:bind id="dateTime-bind" ref="dateTime" name="dateTime" type="xf:dateTime"/>
                    <xf:bind id="date2-bind" ref="date2" name="date2" type="xf:date"/>
                    <xf:bind id="date3-bind" ref="date3" name="date3" type="xf:date"/>
                    <xf:bind id="grid-19-bind" ref="grid-19" name="grid-19">
                        <xf:bind id="options-bind" ref="options" name="options"/>
                        <xf:bind id="otherOptions-bind" ref="otherOptions" name="otherOptions"/>
                    </xf:bind>
                    <xf:bind id="details-bind" ref="details" name="details"/>
                    <xf:bind id="type-bind" ref="type" name="type"/>
                    <xf:bind id="section-24-bind" ref="section-24" name="section-24">
                        <xf:bind id="formatedText-bind" ref="formatedText" name="formatedText"/>
                    </xf:bind>
                </xf:bind>
            </xf:bind>
            <!!-- Metadata -->
            <xf:instance xxf:readonly="true" id="fr-form-metadata" xxf:exclude-result-prefixes="#all">
                <metadata>
                    <application-name>agesic</application-name>
                    <form-name>test</form-name>
                    <title xml:lang="en">Test</title>
                    <description xml:lang="en"/>
                    <permissions>
                        <permission operations="create"/>
                        <permission operations="read update delete">
                            <user-role any-of="orbeon-agesic-uaip-admin"/>
                        </permission>
                    </permissions>
                </metadata>
            </xf:instance>
            <!!-- Attachments -->
            <xf:instance id="fr-form-attachments" xxf:exclude-result-prefixes="#all">
                <attachments>
                    <css mediatype="text/css" filename="" size=""/>
                    <pdf mediatype="application/pdf" filename="" size=""/>
                </attachments>
            </xf:instance>
            <!!-- All form resources -->
            <!!-- Dont make readonly by default in case a service modifies the resources -->
            <xf:instance id="fr-form-resources" xxf:readonly="false" xxf:exclude-result-prefixes="#all">
                <resources>
                    <resource xml:lang="en">
                        <formatedText>
                            <label>Formatted Text</label>
                            <hint/>
                        </formatedText>
                        <options>
                            <label>Options</label>
                            <hint/>
                            <item>
                                <label>First choice</label>
                                <value>1</value>
                                <hint/>
                            </item>
                            <item>
                                <label>Second choice</label>
                                <value>2</value>
                                <hint/>
                            </item>
                            <item>
                                <label>Third choice</label>
                                <value>3</value>
                                <hint/>
                            </item>
                        </options>
                        <otherOptions>
                            <label>Other Options</label>
                            <hint/>
                            <item>
                                <label>First choice</label>
                                <value>1</value>
                            </item>
                            <item>
                                <label>Second choice</label>
                                <value>2</value>
                            </item>
                            <item>
                                <label>Third choice</label>
                                <value>3</value>
                            </item>
                        </otherOptions>
                        <section-24>
                            <label>Section 2.1</label>
                            <help/>
                        </section-24>
                        <date1>
                            <label>Date 1</label>
                            <hint/>
                        </date1>
                        <dateTime>
                            <label>Date and Time</label>
                            <hint/>
                        </dateTime>
                        <date2>
                            <label>Date 2</label>
                            <hint/>
                        </date2>
                        <date3>
                            <label>Date 3</label>
                            <hint/>
                        </date3>
                        <details>
                            <label>Details</label>
                            <hint/>
                        </details>
                        <type>
                            <label>Type</label>
                            <hint/>
                            <item>
                                <label>First choice</label>
                                <value>1</value>
                                <hint/>
                            </item>
                            <item>
                                <label>Second choice</label>
                                <value>2</value>
                                <hint/>
                            </item>
                            <item>
                                <label>Third choice</label>
                                <value>3</value>
                                <hint/>
                            </item>
                        </type>
                        <moneySubject>
                            <label>Subject</label>
                            <hint/>
                            <item>
                                <label>First choice</label>
                                <value>1</value>
                            </item>
                            <item>
                                <label>Second choice</label>
                                <value>2</value>
                            </item>
                            <item>
                                <label>Third choice</label>
                                <value>3</value>
                            </item>
                        </moneySubject>
                        <quantity>
                            <label>Quantity</label>
                            <hint/>
                        </quantity>
                        <currency>
                            <label>Currency</label>
                            <hint/>
                        </currency>
                        <section-14>
                            <label>Section 2</label>
                            <help/>
                        </section-14>
                        <control-8>
                            <label>Here we enter the mobile phones</label>
                            <hint/>
                        </control-8>
                        <mobile>
                            <label>Mobile</label>
                            <hint/>
                        </mobile>
                        <section-1>
                            <label>Section 1</label>
                        </section-1>
                        <name>
                            <label>Name</label>
                            <hint/>
                        </name>
                        <surname>
                            <label>Surname</label>
                            <hint/>
                        </surname>
                        <phone>
                            <label>Phone</label>
                            <hint/>
                        </phone>
                        <mail>
                            <label>Mail</label>
                            <hint/>
                        </mail>
                        <section-7>
                            <label>Complex Data</label>
                            <help/>
                        </section-7>
                    </resource>
                </resources>
            </xf:instance>
            <!!-- Utility instances for services -->
            <xf:instance id="fr-service-request-instance" xxf:exclude-result-prefixes="#all">
                <request/>
            </xf:instance>
            <xf:instance id="fr-service-response-instance" xxf:exclude-result-prefixes="#all">
                <response/>
            </xf:instance>
            <xf:instance xxf:readonly="true" id="section-1-template">
                <section-1-iteration>
                    <name/>
                    <surname/>
                    <phone/>
                    <mail/>
                    <section-7>
                        <control-8/>
                        <mobile/>
                        <grid-10>
                            <quantity/>
                            <currency/>
                            <moneySubject/>
                        </grid-10>
                    </section-7>
                </section-1-iteration>
            </xf:instance>
            <xf:instance xxf:readonly="true" id="grid-10-template">
                <grid-10>
                    <quantity/>
                    <currency/>
                    <moneySubject/>
                </grid-10>
            </xf:instance>
            <xf:instance xxf:readonly="true" id="grid-19-template">
                <grid-19>
                    <options/>
                    <otherOptions/>
                </grid-19>
            </xf:instance>
        </xf:model>
    </xh:head>
    <xh:body>
        <fr:view>
            <fr:body xmlns:xbl="http://www.w3.org/ns/xbl" xmlns:p="http://www.orbeon.com/oxf/pipeline"
                     xmlns:oxf="http://www.orbeon.com/oxf/processors">
                <fr:section id="section-1-control" bind="section-1-bind" repeat="true" min="1"
                            template="instance(''section-1-template'')">
                    <xf:label ref="$form-resources/section-1/label"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="name-control" bind="name-bind" class="fr-summary fr-search">
                                    <xf:label ref="$form-resources/name/label"/>
                                    <xf:hint ref="$form-resources/name/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="surname-control" bind="surname-bind" class="fr-summary fr-search">
                                    <xf:label ref="$form-resources/surname/label"/>
                                    <xf:hint ref="$form-resources/surname/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <fr:us-phone xmlns="http://orbeon.org/oxf/xml/form-builder"
                                             xmlns:xxbl="http://orbeon.org/oxf/xml/xbl"
                                             id="phone-control"
                                             bind="phone-bind"
                                             class="fr-summary fr-search">
                                    <xf:label ref="$form-resources/phone/label"/>
                                    <xf:hint ref="$form-resources/phone/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </fr:us-phone>
                            </xh:td>
                            <xh:td>
                                <xf:input id="mail-control" bind="mail-bind">
                                    <xf:label ref="$form-resources/mail/label"/>
                                    <xf:hint ref="$form-resources/mail/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                    <fr:section id="section-7-control" bind="section-7-bind">
                        <xf:label ref="$form-resources/section-7/label"/>
                        <fr:grid>
                            <xh:tr>
                                <xh:td>
                                    <xf:output id="control-8-control" bind="control-8-bind">
                                        <xf:label ref="$form-resources/control-8/label"/>
                                        <xf:hint ref="$form-resources/control-8/hint"/>
                                        <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    </xf:output>
                                </xh:td>
                            </xh:tr>
                            <xh:tr>
                                <xh:td>
                                    <xf:input id="mobile-control" bind="mobile-bind">
                                        <xf:label ref="$form-resources/mobile/label"/>
                                        <xf:hint ref="$form-resources/mobile/hint"/>
                                        <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    </xf:input>
                                </xh:td>
                            </xh:tr>
                        </fr:grid>
                        <fr:grid id="grid-10-grid" repeat="true" bind="grid-10-bind"
                                 template="instance(''grid-10-template'')"
                                 min="1">
                            <xh:tr>
                                <xh:td>
                                    <fr:dropdown-select1 xmlns:xxbl="http://orbeon.org/oxf/xml/xbl" id="moneySubject-control"
                                                         bind="moneySubject-bind">
                                        <xf:label ref="$form-resources/moneySubject/label"/>
                                        <xf:hint ref="$form-resources/moneySubject/hint"/>
                                        <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                        <xf:itemset ref="$form-resources/moneySubject/item">
                                            <xf:label ref="label"/>
                                            <xf:value ref="value"/>
                                        </xf:itemset>
                                    </fr:dropdown-select1>
                                </xh:td>
                                <xh:td>
                                    <fr:number xmlns="http://orbeon.org/oxf/xml/form-builder"
                                               xmlns:xxbl="http://orbeon.org/oxf/xml/xbl"
                                               xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                                               id="quantity-control"
                                               bind="quantity-bind">
                                        <xf:label ref="$form-resources/quantity/label"/>
                                        <xf:hint ref="$form-resources/quantity/hint"/>
                                        <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    </fr:number>
                                </xh:td>
                                <xh:td>
                                    <fr:currency xmlns="http://orbeon.org/oxf/xml/form-builder"
                                                 xmlns:xxbl="http://orbeon.org/oxf/xml/xbl"
                                                 id="currency-control"
                                                 bind="currency-bind">
                                        <xf:label ref="$form-resources/currency/label"/>
                                        <xf:hint ref="$form-resources/currency/hint"/>
                                        <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    </fr:currency>
                                </xh:td>
                            </xh:tr>
                        </fr:grid>
                    </fr:section>
                </fr:section>
                <fr:section id="section-14-control" bind="section-14-bind">
                    <xf:label ref="$form-resources/section-14/label"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="date1-control" bind="date1-bind">
                                    <xf:label ref="$form-resources/date1/label"/>
                                    <xf:hint ref="$form-resources/date1/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="dateTime-control" bind="dateTime-bind">
                                    <xf:label ref="$form-resources/dateTime/label"/>
                                    <xf:hint ref="$form-resources/dateTime/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <fr:dropdown-date xmlns="http://orbeon.org/oxf/xml/form-builder"
                                                  xmlns:xxbl="http://orbeon.org/oxf/xml/xbl"
                                                  id="date2-control"
                                                  bind="date2-bind">
                                    <xf:label ref="$form-resources/date2/label"/>
                                    <xf:hint ref="$form-resources/date2/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </fr:dropdown-date>
                            </xh:td>
                            <xh:td>
                                <fr:fields-date xmlns="http://orbeon.org/oxf/xml/form-builder"
                                                xmlns:xxbl="http://orbeon.org/oxf/xml/xbl"
                                                id="date3-control"
                                                bind="date3-bind">
                                    <xf:label ref="$form-resources/date3/label"/>
                                    <xf:hint ref="$form-resources/date3/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </fr:fields-date>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:textarea id="details-control" bind="details-bind">
                                    <xf:label ref="$form-resources/details/label"/>
                                    <xf:hint ref="$form-resources/details/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:textarea>
                            </xh:td>
                            <xh:td>
                                <xf:select1 id="type-control" appearance="full" bind="type-bind">
                                    <xf:label ref="$form-resources/type/label"/>
                                    <xf:hint ref="$form-resources/type/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    <xf:itemset ref="$form-resources/type/item">
                                        <xf:label ref="label"/>
                                        <xf:value ref="value"/>
                                        <xf:hint ref="hint"/>
                                    </xf:itemset>
                                </xf:select1>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                    <fr:grid id="grid-19-grid" repeat="true" bind="grid-19-bind"
                             template="instance(''grid-19-template'')"
                             min="1">
                        <xh:tr>
                            <xh:td>
                                <xf:select id="options-control" appearance="full" bind="options-bind">
                                    <xf:label ref="$form-resources/options/label"/>
                                    <xf:hint ref="$form-resources/options/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    <xf:itemset ref="$form-resources/options/item">
                                        <xf:label ref="label"/>
                                        <xf:value ref="value"/>
                                        <xf:hint ref="hint"/>
                                    </xf:itemset>
                                </xf:select>
                            </xh:td>
                            <xh:td>
                                <xf:select1 id="otherOptions-control" appearance="compact" bind="otherOptions-bind">
                                    <xf:label ref="$form-resources/otherOptions/label"/>
                                    <xf:hint ref="$form-resources/otherOptions/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    <xf:itemset ref="$form-resources/otherOptions/item">
                                        <xf:label ref="label"/>
                                        <xf:value ref="value"/>
                                    </xf:itemset>
                                </xf:select1>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                    <fr:section id="section-24-control" bind="section-24-bind">
                        <xf:label ref="$form-resources/section-24/label"/>
                        <fr:grid>
                            <xh:tr>
                                <xh:td>
                                    <fr:tinymce xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                                                xmlns:xxbl="http://orbeon.org/oxf/xml/xbl"
                                                xmlns:f="http://orbeon.org/oxf/xml/formatting"
                                                id="formatedText-control"
                                                bind="formatedText-bind">
                                        <xf:label ref="$form-resources/formatedText/label"/>
                                        <xf:hint ref="$form-resources/formatedText/hint"/>
                                        <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    </fr:tinymce>
                                </xh:td>
                            </xh:tr>
                        </fr:grid>
                    </fr:section>
                </fr:section>
            </fr:body>
        </fr:view>
    </xh:body>
</xh:html>'! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 14:15'!
setUp

	"reader := OrbeonFormReader for: self getXMLForm."

	reader := OrbeonXPathFormReader for: self getXMLForm.! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 15:28'!
testApplicationName

	self assert: (reader getApplicationName = 'agesic')! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 15:30'!
testDescription

	self assert: (reader getDescription = '')! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 13:46'!
testFieldTypes
	| fieldTypes |

	fieldTypes := reader getFieldTypes. "includes all fields inside a repeatable grid or not"

	self assert: ((fieldTypes at: 'name' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'surname' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'phone' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'mobile' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'moneySubject' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'quantity' ifAbsent: ['']) = 'xf:decimal').
	self assert: ((fieldTypes at: 'currency' ifAbsent: ['']) = 'xf:decimal').
	self assert: ((fieldTypes at: 'date1' ifAbsent: ['']) = 'xf:date').
	self assert: ((fieldTypes at: 'date2' ifAbsent: ['']) = 'xf:date').
	self assert: ((fieldTypes at: 'date3' ifAbsent: ['']) = 'xf:date').
	self assert: ((fieldTypes at: 'dateTime' ifAbsent: ['']) = 'xf:dateTime').
	self assert: ((fieldTypes at: 'details' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'type' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'options' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'otherOptions' ifAbsent: ['']) = 'xf:string').
	self assert: ((fieldTypes at: 'formatedText' ifAbsent: ['']) = 'xf:string').! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 11:45'!
testFormFieldsLabels
	| section1 labels |

	section1 := reader formMainSections first.
	labels := reader formFieldsLabels. 

	self assert: ((labels at: 'name' ifAbsent: ['']) = 'Name').
	self assert: ((labels at: 'surname' ifAbsent: ['']) = 'Surname').
	self assert: ((labels at: 'phone' ifAbsent: ['']) = 'Phone').
	self assert: ((labels at: 'mail' ifAbsent: ['']) = 'Mail').
	self assert: ((labels at: 'control-8' ifAbsent: ['']) = 'Here we enter the mobile phones').
	self assert: ((labels at: 'moneySubject' ifAbsent: ['']) = 'Subject').
	self assert: ((labels at: 'quantity' ifAbsent: ['']) = 'Quantity').
	self assert: ((labels at: 'currency' ifAbsent: ['']) = 'Currency').
	self assert: ((labels at: 'currency' ifAbsent: ['']) = 'Currency').
	self assert: ((labels at: 'date1' ifAbsent: ['']) = 'Date 1').
	self assert: ((labels at: 'dateTime' ifAbsent: ['']) = 'Date and Time').
	self assert: ((labels at: 'date2' ifAbsent: ['']) = 'Date 2').
	self assert: ((labels at: 'date3' ifAbsent: ['']) = 'Date 3').
	self assert: ((labels at: 'details' ifAbsent: ['']) = 'Details').
	self assert: ((labels at: 'type' ifAbsent: ['']) = 'Type').
	self assert: ((labels at: 'options' ifAbsent: ['']) = 'Options').
	self assert: ((labels at: 'otherOptions' ifAbsent: ['']) = 'Other Options').
	self assert: ((labels at: 'formatedText' ifAbsent: ['']) = 'Formatted Text').! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 16:07'!
testFormMainSectionsNames

	self assert: ((reader formMainSections first attributeAt: 'id') = 'section-1-control').

	self assert: ((reader formMainSections second attributeAt: 'id') = 'section-14-control').! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 16:01'!
testFormMainSectionsSize

	self assert: (reader formMainSections size = 2)! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 15:29'!
testFormName

	self assert: (reader getFormName = 'test')! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 10:35'!
testFormSubSectionsStructure
	| section1 section11 section2 section21 |

	section1 := reader formMainSections first.
	section11 := (reader formSubSectionsOf: section1) last.
	section2 := reader formMainSections second.
	section21 := (reader formSubSectionsOf: section2) last.

	self assert:  (reader formSubSectionsOf: section1) size = 1.
	self assert:  (reader formSubSectionsOf: section2) size = 1.

	self assert: ((section11 attributeAt: 'id') = 'section-7-control').
	self assert: ((section21 attributeAt: 'id') = 'section-24-control').

	self assert: ((reader formFieldsIn: section1) size = 4).
	self assert: ((reader formFieldsIn: section11) size = 2). "Fields inside Repeatable GRIDS [fr:grid] are ingnored"
	self assert: ((reader formFieldsIn: section2) size = 6). "Fields inside Repeatable GRIDS [fr:grid] are ingnored"
	self assert: ((reader formFieldsIn: section21) size = 1).! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 10:36'!
testGetAllFormFieldsInSection1
	| section1 allFields |

	section1 := reader formMainSections first.
	allFields := reader getAllFormFieldsIn: section1. "includes all fields inside a repeatable grid or not"

	self assert: (allFields size = 9).! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 10:37'!
testGetAllFormFieldsInSection2
	| section2 allFields |

	section2 := reader formMainSections second.
	allFields := reader getAllFormFieldsIn: section2. "includes all fields inside a repeatable grid or not"

	self assert: (allFields size = 9).! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 12:37'!
testGetFieldsOfGridsInSection1
	| section1 section11 grids grid fields |

	section1 := reader formMainSections first.
	section11 := (reader formSubSectionsOf: section1) last.

	grids := reader formGridComponentsIn: section11.
	grid := grids first.
	fields := reader formGridFieldsIn: grid.

	self assert: (fields size = 3).
	self assert: (fields anySatisfy: [:e | (e attributeAt: 'id') = 'moneySubject-control']).
	self assert: (fields anySatisfy: [:e | (e attributeAt: 'id') = 'quantity-control']).
	self assert: (fields anySatisfy: [:e | (e attributeAt: 'id') = 'currency-control']).! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 12:52'!
testGetFieldsOfGridsInSection2
	| section2 grids grid fields |

	section2 := reader formMainSections second.

	grids := reader formGridComponentsIn: section2.
	grid := grids first.
	fields := reader formGridFieldsIn: grid.

	self assert: (fields size = 2).
	self assert: (fields anySatisfy: [:e | (e attributeAt: 'id') = 'options-control']).
	self assert: (fields anySatisfy: [:e | (e attributeAt: 'id') = 'otherOptions-control']).! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 12:10'!
testGetGridsFromSection1
	| section1 section11 grids |

	section1 := reader formMainSections first.
	section11 := (reader formSubSectionsOf: section1) last.

	grids := reader formGridComponentsIn: section1.
	self assert: (grids size = 0).

	grids := reader formGridComponentsIn: section11.
	self assert: (grids size = 1).
	self assert: ((grids first attributeAt: 'id') = 'grid-10-grid').! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 12:11'!
testGetGridsFromSection2
	| section2 section21 grids |

	section2 := reader formMainSections second.
	section21 := (reader formSubSectionsOf: section2) last.

	grids := reader formGridComponentsIn: section21.
	self assert: (grids size = 0).

	grids := reader formGridComponentsIn: section2.
	self assert: (grids size = 1).
	self assert: ((grids first attributeAt: 'id') = 'grid-19-grid').! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 15:45'!
testGetPermissions
	| permissions |

	permissions := reader getPermissions.

	self assert: (permissions class == OrbeonPermissions).

	self assert: (permissions hasCreateAccess: 'orbeon-agesic-uaip-admin').
	self assert: (permissions hasReadAccess: 'orbeon-agesic-uaip-admin').
	self assert: (permissions hasUpdateAccess: 'orbeon-agesic-uaip-admin').
	self assert: (permissions hasDeleteAccess: 'orbeon-agesic-uaip-admin').

	self assert: (permissions hasCreateAccess: 'x-role').
	self assert: (permissions hasReadAccess: 'x-role') not.
	self assert: (permissions hasUpdateAccess: 'x-role') not.
	self assert: (permissions hasDeleteAccess: 'x-role') not.! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 14:01'!
testGetSearchFields
	| section1 searchFields |

	section1 := reader formMainSections first.
	searchFields := reader searchFormFieldsIn: section1.

	self assert: (searchFields size = 3).
	self assert: (searchFields anySatisfy: [:e | (e attributeAt: 'id') = 'name-control']).
	self assert: (searchFields anySatisfy: [:e | (e attributeAt: 'id') = 'surname-control']).
	self assert: (searchFields anySatisfy: [:e | (e attributeAt: 'id') = 'phone-control']).! !

!OrbeonFormReaderTestExample3 methodsFor: 'other' stamp: 'BrunoBB 03/17/2016 14:04'!
testGetSummaryFields
	| section1 summaryFields |

	section1 := reader formMainSections first.
	summaryFields := reader summaryFormFieldsIn: section1.

	self assert: (summaryFields size = 3).
	self assert: (summaryFields anySatisfy: [:e | (e attributeAt: 'id') = 'name-control']).
	self assert: (summaryFields anySatisfy: [:e | (e attributeAt: 'id') = 'surname-control']).
	self assert: (summaryFields anySatisfy: [:e | (e attributeAt: 'id') = 'phone-control']).! !

TestCase subclass: #OrbeonFormTest
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

OrbeonFormTest subclass: #OrbeonFormDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

!OrbeonFormDefinitionTest methodsFor: 'other' stamp: 'BrunoBB 10/17/2015 13:57'!
setUp

	super setUp.

	form := OrbeonFormDefinition new.! !

!OrbeonFormDefinitionTest methodsFor: 'other' stamp: 'BrunoBB 10/17/2015 10:37'!
tearDown! !

!OrbeonFormDefinitionTest methodsFor: 'other' stamp: 'BrunoBB 10/17/2015 13:57'!
testName

	self assert: (form form isEmpty)! !

!OrbeonFormDefinitionTest methodsFor: 'other' stamp: 'BrunoBB 10/17/2015 13:57'!
testName2

	self assert: (form form isEmpty)! !

!OrbeonFormDefinitionTest methodsFor: 'other' stamp: 'BrunoBB 10/17/2015 11:40'!
testName3

	self assert: true! !

!OrbeonFormDefinitionTest methodsFor: 'other' stamp: 'BrunoBB 10/18/2015 12:19'!
testName4

	self assert: true.

	self assert: true foo! !

OrbeonFormTest subclass: #OrbeonFormInstanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!

TestCase subclass: #OrbeonHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Tests'!
